# $Revision: 1.39 $, $Date: 2008/01/06 22:42:22 $
#
# Conditional build:
%bcond_without	php	# don't build (any) PHP bindings
%bcond_without	ruby	# don't build Ruby bindings
%bcond_with	php4	# build PHP4 bindings (default PHP5)
#
%include	/usr/lib/rpm/macros.perl
Summary:	Redland RDF Application Framework Bindings
Summary(pl.UTF-8):	Wiązania szkieletu aplikacji Redland RDF
Name:		redland-bindings
Version:	1.0.7.1
Release:	1
License:	LGPL v2.1+ or GPL v2+ or Apache 2.0
Group:		Libraries
Source0:	http://download.librdf.org/source/%{name}-%{version}.tar.gz
# Source0-md5:	ad38f4b5d4f55a87359ebff047a00184
Patch0:		%{name}-py_sitescriptdir.patch
Patch1:		%{name}-php.patch
URL:		http://librdf.org/bindings/
BuildRequires:	autoconf >= 2.53
BuildRequires:	automake >= 1:1.7
BuildRequires:	libtool
BuildRequires:	perl-devel >= 1:5.8.0
BuildRequires:	python-devel
BuildRequires:	redland-devel >= 1.0.7
BuildRequires:	rpm-perlprov >= 4.1-13
BuildRequires:	rpmbuild(macros) >= 1.344
%if %{with php}
%if %{with php4}
BuildRequires:	php4-cli
BuildRequires:	php4-devel
%else
BuildRequires:	php-cli >= 3:5.0.0
BuildRequires:	php-devel >= 3:5.0.0
%endif
BuildRequires:	swig-php >= 1.3.29
%endif
%if %{with ruby}
BuildRequires:	ruby-devel
%endif
Obsoletes:	dotnet-redland
Obsoletes:	java-redland
Obsoletes:	tcl-redland
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Redland is a library that provides a high-level interface for the
Resource Description Framework (RDF) allowing the RDF graph to be
parsed from XML, stored, queried and manipulated. Redland implements
each of the RDF concepts in its own class via an object based API,
reflected into the language APIs, currently C#, Java, Perl, PHP,
Python, Ruby and Tcl. Several classes providing functionality such as
for parsers, storage are built as modules that can be loaded at
compile or run-time as required.

%description -l pl.UTF-8
Redland to biblioteka dostarczająca wysokopoziomowy interfejs dla
szkieletu opisu zasobów (RDF - Resource Description Framework),
umożliwiająca na przetwarzanie grafów XML z RDF, przechowywanie,
odpytywanie i obrabianie ich. Redland implementuje wszystkie idee RDF
we własnych klasach poprzez API oparte na obiektach, mających
odzwierciedlenie w API dla poszczególnych języków - aktualnie C#, Java
Perl, PHP, Python, Ruby i Tcl. Kilka klas dostarczających
funkcjonalność dla parserów i przechowywania danych jest budowana jako
moduły, które mogą być wczytywane w czasie kompilacji lub działania
programu w razie potrzeby.

%package -n perl-RDF-Redland
Summary:	Perl bindings for Redland RDF library
Summary(pl.UTF-8):	Perlowy interfejs do biblioteki Redland RDF
Group:		Development/Languages/Perl

%description -n perl-RDF-Redland
Perl bindings for Redland RDF library.

%description -n perl-RDF-Redland -l pl.UTF-8
Perlowy interfejs do biblioteki Redland RDF.

%package -n php4-redland
Summary:	PHP bindings for Redland RDF library
Summary(pl.UTF-8):	Interfejs PHP do biblioteki Redland RDF
Group:		Libraries
%{?requires_php_extension}
Requires:	php4-common >= 3:4.4.0-3

%description -n php4-redland
PHP 4.x bindings for Redland RDF library.

%description -n php4-redland -l pl.UTF-8
Interfejs PHP 4.x do biblioteki Redland RDF.

%package -n php-redland
Summary:	PHP 5.x bindings for Redland RDF library
Summary(pl.UTF-8):	Interfejs PHP 5.x do biblioteki Redland RDF
Group:		Libraries
%{?requires_php_extension}
Requires:	php-common >= 4:5.0.4

%description -n php-redland
PHP 5.x bindings for Redland RDF library.

%description -n php-redland -l pl.UTF-8
Interfejs PHP 5.x do biblioteki Redland RDF.

%package -n python-redland
Summary:	Python bindings for Redland RDF library
Summary(pl.UTF-8):	Pythonowy interfejs do biblioteki Redland RDF
Group:		Libraries/Python
%pyrequires_eq	python

%description -n python-redland
Python bindings for Redland RDF library.

%description -n python-redland -l pl.UTF-8
Pythonowy interfejs do biblioteki Redland RDF.

%package -n ruby-redland
Summary:	Ruby bindings for Redland RDF library
Summary(pl.UTF-8):	Interfejs języka Ruby do biblioteki Redland RDF
Group:		Libraries
%{?ruby_mod_ver_requires_eq}

%description -n ruby-redland
Ruby bindings for Redland RDF library.

%description -n ruby-redland -l pl.UTF-8
Interfejs języka Ruby do biblioteki Redland RDF.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

# force regeneration
rm -f php/{php_redland.h,redland_wrap.c}

%build
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__automake}
%configure \
	--disable-static \
	--with-perl \
%if %{with php}
	--with-php=%{_bindir}/php%{?with_php4:4}.cli \
%endif
	--with-python \
	%{?with_ruby:--with-ruby}

%{__make} \
	MAKE_PL_OPTS='INSTALLDIRS=vendor OPTIMIZE="%{rpmcflags}"' \
	pythondir=%{py_sitedir}

%if %{with ruby}
cd ruby
rdoc --op ../rdoc
cd ..
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	pythondir=%{py_sitedir}

%py_comp $RPM_BUILD_ROOT%{py_sitescriptdir}
%py_ocomp $RPM_BUILD_ROOT%{py_sitescriptdir}
rm $RPM_BUILD_ROOT%{py_sitescriptdir}/*.py

%if %{with php}
install -d $RPM_BUILD_ROOT{%{php_sysconfdir}/conf.d,%{php_extensiondir}}
cat <<'EOF' > $RPM_BUILD_ROOT%{php_sysconfdir}/conf.d/redland.ini
; Enable redland bindings module
extension=redland.so
EOF
# make .so executable so that rpm would add autodeps on .so files
chmod +x $RPM_BUILD_ROOT%{php_extensiondir}/*.so
%endif

rm -f $RPM_BUILD_ROOT%{perl_archlib}/perllocal.pod
rm -f $RPM_BUILD_ROOT%{perl_vendorarch}/auto/RDF/Redland/CORE/.packlist

%clean
rm -rf $RPM_BUILD_ROOT

%post -n php-redland
%php_webserver_restart

%postun -n php-redland
if [ "$1" = 0 ]; then
	%php_webserver_restart
fi

%post -n php4-redland
%php4_webserver_restart

%postun -n php4-redland
if [ "$1" = 0 ]; then
	%php4_webserver_restart
fi

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog* LICENSE.html NEWS.html README.html RELEASE.html TODO.html

%files -n perl-RDF-Redland
%defattr(644,root,root,755)
%doc docs/perl.html
%dir %{perl_vendorarch}/RDF
%{perl_vendorarch}/RDF/Redland.pm
%{perl_vendorarch}/RDF/Redland
%dir %{perl_vendorarch}/auto/RDF
%dir %{perl_vendorarch}/auto/RDF/Redland
%dir %{perl_vendorarch}/auto/RDF/Redland/CORE
%{perl_vendorarch}/auto/RDF/Redland/CORE/CORE.bs
%attr(755,root,root) %{perl_vendorarch}/auto/RDF/Redland/CORE/CORE.so
%{_mandir}/man3/RDF::Redland*.3pm*

%if %{with php}
%files -n php%{?with_php4:4}-redland
%defattr(644,root,root,755)
%doc docs/php.html
%config(noreplace) %verify(not md5 mtime size) %{php_sysconfdir}/conf.d/redland.ini
%attr(755,root,root) %{php_extensiondir}/redland.so
%endif

%files -n python-redland
%defattr(644,root,root,755)
%doc docs/python.html docs/pydoc
%{py_sitescriptdir}/RDF.py[co]
%attr(755,root,root) %{py_sitedir}/Redland.so

%if %{with ruby}
%files -n ruby-redland
%defattr(644,root,root,755)
%doc docs/ruby.html rdoc
%attr(755,root,root) %{ruby_archdir}/redland.so
%dir %{ruby_rubylibdir}/rdf
%{ruby_rubylibdir}/rdf/redland.rb
%{ruby_rubylibdir}/rdf/redland
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: redland-bindings.spec,v $
Revision 1.39  2008/01/06 22:42:22  qboosh
- updated to 1.0.7.1; C#, Java and Tcl bindings dropped
- removed obsolete csharp patch, added php patch

Revision 1.38  2007-05-12 08:54:12  qboosh
- updated to 1.0.6.1

Revision 1.37  2007/03/19 14:57:52  glen
- AC-branch merge

Revision 1.36  2007/02/13 08:06:44  glen
- tabs in preamble

Revision 1.35  2007/02/12 01:06:30  baggins
- converted to UTF-8

Revision 1.34  2007/02/03 17:54:29  qboosh
- updated to 1.0.5.1
- updated csharp patch, removed obsolete install patch

Revision 1.33  2006/11/02 23:09:09  glen
- BR rpmmacros for fixed %requires_php_extension

Revision 1.32  2006/05/28 07:13:21  qboosh
- updated to 1.0.4.1, removed obsolete java patch

Revision 1.31  2006/03/25 14:06:11  qboosh
- updated to 1.0.3.1, added java,csharp patches
- build C#/mono binding

Revision 1.30  2006/01/01 12:34:14  twittner
- fix macro name - %ruby_libdir -> %ruby_rubylibdir
- rel. 8, STBR
- now builds, but warnings expose include files and definitions clash:

 In file included from /usr/lib/ruby/1.8/i686-linux/ruby.h:24,
                  from redland_wrap.c:24:
 /usr/lib/ruby/1.8/i686-linux/config.h:2:1: warning: "PACKAGE_NAME" redefined
 <command line>:4:1: warning: this is the location of the previous definition
 /usr/lib/ruby/1.8/i686-linux/config.h:3:1: warning: "PACKAGE_TARNAME" redefined
 <command line>:5:1: warning: this is the location of the previous definition
 /usr/lib/ruby/1.8/i686-linux/config.h:4:1: warning: "PACKAGE_VERSION" redefined
 <command line>:6:1: warning: this is the location of the previous definition
 /usr/lib/ruby/1.8/i686-linux/config.h:5:1: warning: "PACKAGE_STRING" redefined
 <command line>:7:1: warning: this is the location of the previous definition
 /usr/lib/ruby/1.8/i686-linux/config.h:6:1: warning: "PACKAGE_BUGREPORT" redefined
 <command line>:8:1: warning: this is the location of the previous definition

Revision 1.29  2005/12/31 10:36:33  twittner
- change %ruby_mod_ver_requires_eq to %{?ruby_mod_ver_requires_eq} -
  expand this macro only if defined to avoid parse error when appropriate
  BRs is not installed yet (solution provided by glen)

Revision 1.28  2005/12/29 16:59:47  twittner
- replace R: ruby-modules with %ruby_mod_ver_requires_eq macro
  defined as `Requires: ruby-modules(ver) = 1.8' where `1.8' is
  major ruby version taken from rbconfig
- add BR: rpmbuild(macros) >= 1.277 with aforementioned macros

Revision 1.27  2005/12/27 10:07:59  twittner
- remove redundant BR: ruby-modules (BR: ruby-devel implies it)

Revision 1.26  2005/12/27 09:19:37  twittner
- (B)R: s/ruby/ruby-modules/, rel. 7 (mass commit through script)

Revision 1.25  2005/12/26 23:50:12  glen
- use system ruby macros; cleanups

Revision 1.24  2005/12/22 12:12:13  glen
- rel 6 (rebuild with new php)

Revision 1.23  2005/10/31 11:05:15  arekm
- rel 5

Revision 1.22  2005/10/27 17:49:53  arekm
- rel 4

Revision 1.21  2005/09/15 19:51:18  glen
- php library must be executable in build dir for rpm to autoreqdep it, rel 3

Revision 1.20  2005/09/15 19:38:18  glen
- php conf.d support and php api version require; rel 2

Revision 1.19  2005/09/07 14:17:31  glen
- autotools called directly, revert last change

Revision 1.18  2005/09/07 13:30:50  glen
- php{,4}-devel already Requires: auto{make,conf}

Revision 1.17  2005/06/12 01:46:24  aredridel
- add orphaned dir
- STBR

Revision 1.16  2005/06/11 01:58:40  aredridel
- up to 1.0.2.1
- removed dependency on base package

Revision 1.15  2005/06/04 09:05:04  qboosh
- added tcl85 bcond

Revision 1.14  2005/05/29 18:27:34  aredridel
- up to 1.0.1.1

Revision 1.13  2005/03/03 22:45:42  qboosh
- updated to 1.0.0.2, removed obsolete php-tsrm patch

Revision 1.12  2005/02/07 19:00:50  qboosh
- updated install patch, include ruby lib files

Revision 1.11  2005/02/07 14:46:05  aredridel
- up to 1.0.0.1

Revision 1.10  2005/01/10 20:42:03  qboosh
- lib64 hacks (make overrides), release 1

Revision 1.9  2005/01/08 23:38:37  qboosh
- updated to 0.9.19.1
- updated py_sitescriptdir patch, added php-tsrm patch
- ruby BR: ruby-devel
- php-cli was needed only for make check, which is not performed

Revision 1.8  2004/12/25 18:04:57  qboosh
- automake epoch

Revision 1.7  2004/12/25 14:50:09  adamg
- looks like build requires php interpreter

Revision 1.6  2004/12/25 14:36:14  adamg
- typo

Revision 1.5  2004/12/25 14:30:33  adamg
- php bcond name changed to php4 - it's behaviour is changed too - by
  default build PHP5 bindings, while passing --with php4 should build
  PHP4 bindings

Revision 1.4  2004/12/25 14:22:48  radzio
- compile .py to .py[co]
- mv .py[co] from %py_sitedir to %py_sitescriptdir (Patch1)

Revision 1.3  2004/12/25 11:43:26  radzio
- fix bcond_ruby (BR)
- add bcond_php (default without - see: http://lists.pld-linux.org/pipermail/pld-devel-pl/2004-December/123480.html)

Revision 1.2  2004/12/24 22:57:17  radzio
- add bcond ruby (default without as Ruby bindings doesn't work - build errors)
- rel 1
- STBR

Revision 1.1  2004/08/04 23:08:38  qboosh
- new; who wants to add mono bindings?
